// Copyright (C) 2003, 2005 Daisuke Arai <darai@users.sourceforge.jp>
// 
// This program is part of Protra.
//
// Protra is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
// 
// $Id: WhileStatementNode.cs,v 1.3 2007-12-27 08:34:39 panacoran Exp $

using System;
using System.Collections;

namespace Protra.Lib.Lang
{
	/// <summary>
	/// while文のノードを表すクラスです。
	/// </summary>
	public class WhileStatementNode : Node
	{
		/// <summary>
		/// 条件式のノード
		/// </summary>
		private Node condNode;
		/// <summary>
		/// ノードのリスト
		/// </summary>
		private ArrayList nodeList = new ArrayList();

		/// <summary>
		/// 文脈を解析します。
		/// </summary>
		/// <exception cref="Protra.Lib.Lang.ParseException">
		/// 文脈にエラーがある場合にthrowされます。
		/// </exception>
		/// <param name="context">コンテキスト</param>
		public override void Parse(Context context)
		{
			this.ContextToken = (ContextToken)context.Current;

			if(! context.MoveNext())
				throw new ParseException("expression is expected", this.ContextToken);
			condNode = new ExpressionNode();
			condNode.Parse(context);

			ContextToken ct = (ContextToken)context.Current;
			string token = ct.ToString();
			if(token != ";")
				throw new ParseException("';' expected", this.ContextToken);

			while(context.MoveNext())
			{
				ct = (ContextToken)context.Current;
				token = ct.ToString();
				if(token == "end")
				{
					context.MoveNext();
					ct = (ContextToken)context.Current;
					token = ct.ToString();
					if(token != ";")
						throw new ParseException("';' expected", this.ContextToken);
					return;
				}

				Node node = new StatementNode();
				node.Parse(context);
				nodeList.Add(node);
			}

			throw new ParseException("unexpected EOF was detected", this.ContextToken);
		}

		/// <summary>
		/// 構文木を簡略化します。
		/// </summary>
		/// <returns>簡略化されたノード</returns>
		public override Node Simplify()
		{
			condNode = condNode.Simplify();
			for(int i = 0; i < nodeList.Count; i++)
			{
				Node node = (Node)nodeList[i];
				nodeList[i] = node.Simplify();
			}
			return this;
		}

		/// <summary>
		/// プログラムを実行します。
		/// </summary>
		/// <exception cref="Protra.Lib.Lang.RuntimeException">
		/// プログラム実行中にエラーが発生した場合にthrowされます。
		/// </exception>
		/// <param name="resource">リソース</param>
		/// <param name="at">@作用素の値</param>
		/// <returns>実行結果</returns>
		public override Value Execute(Resource resource, int at)
		{
			Value val = condNode.Execute(resource, at);
			while(val != null && val.IsTrue)
			{
				try
				{
					foreach(Node node in nodeList)
						node.Execute(resource, at);
				}
				catch(BreakStatementExecutedException)
				{
					break;
				}
				catch(ContinueStatementExecutedException)
				{
				}

				val = condNode.Execute(resource, at);
			}

			return null;
		}
	}
}
